#CLI controller 
#require 'pry'

class TopBoxOffice::CLI

  def call
    Movie.scrape_all
    list
    menu
  end  

  def list
    puts "************ Top Box Office Movies ************"
    puts ""
    puts Movie.weekend_date
    puts ""
    Movie.all.each.with_index(1) do |movie, i|
      puts "#{i}. #{movie.name}"
    end
  end

  def menu
    input = nil
    until input == "exit" 
      puts ""
      puts "Which movie would you like to know more about?"
      puts "" 
      puts "Type 'list' to see all of the movies or type 'exit' to end the program"
      puts ""
      input = gets.strip.downcase 
      if input == "list"
        list
      # elsif !input.to_i.between?(1, Movie.all.size)
      #   puts "Invalid input, try again"
      #   menu
      elsif input.to_i.between?(1, Movie.all.size)
        movie = Movie.find(input) 
        puts "---------------------------------------------------------------"
        puts "#{movie.name}:"
        puts "Weekend Box Office sales: #{movie.weekend_box}"
        puts "Overall Box Office sales: #{movie.gross_box}"
        puts "Number of weeks at the top of the box office: #{movie.number_weeks}"
        puts "---------------------------------------------------------------"
      end 
    end 
    puts "Come back next weekend to see what movies topped the box office!"
  end 
end #ends class 