require 'pry'

class Movie 
  attr_accessor :name, :weekend_box, :gross_box, :number_weeks

  @@all = []

  def self.all 
    @@all 
  end 

  def save 
    @@all << self 
  end 

  def self.find(id)
    self.all[id.to_i - 1]
  end

  def self.find_by_name(movie)
    self.all.detect do |mov|
      mov.movie.downcase.strip == movie.downcase.strip ||
      mov.movie.split("").first.strip.downcase == movie.downcase.strip
    end
  end


  def self.doc 
    @@doc ||= Nokogiri::HTML(open("http://www.imdb.com/chart/"))
  end 

  def self.weekend_date
    @@weekend_date ||= doc.search("#boxoffice.article.listo h4").text
  end

  def self.movie_names
    @@movie_names ||= doc.search(".titleColumn").collect{|e| e.text.strip}
  end

  def self.weekend_sales
    @@weekend_sales ||= doc.search(".titleColumn+.ratingColumn").collect{|e| e.text.strip}
  end 

  def self.gross_sales
    @@gross_sales ||= doc.search(".secondaryInfo").collect{|e| e.text.strip}
  end

  def self.num_weeks
    @@num_weeks ||= doc.search(".weeksColumn").collect{|e| e.text.strip}
  end

  def self.scrape_all 
    (0..movie_names.size-1).to_a.each do |i|
      movie_name = movie_names[i]
      weekend_box = weekend_sales[i]
      gross_box = gross_sales[i] 
      number_weeks = num_weeks[i]

      movie = Movie.new 
      movie.name = movie_name 
      movie.weekend_box = weekend_box
      movie.gross_box = gross_box
      movie.number_weeks = number_weeks 
      movie.save 
    end
  end 

end #ends class